public class Tester {
	boolean [] G;
	boolean [] B;
	public void start() {
		test(4);
 		}

public void test(int n) {
	for (int i=0; i<Math.pow(2,n); i++) {
		double v = i + 0.5;
		boolean[] G = new boolean[n];
		AtoD(v,G);
		System.out.print(i+":  ");
		display(G);
		System.out.println();
		}
	}

/* ALGORITHM A7: CONVERSION OF ANALOG SIGNAL V TO GRAY CODE */
public void AtoD(double v, boolean[] G){
	int n = G.length;
	double v2 = v - Math.pow(2,n-1);
	G[n-1] = (v2>0);
	double v1 = Math.abs(v2);
	for (int i=n-2; i>=0; i--) {
		v2 = (v1- Math.pow(2,i));
		G[i] = (v2<0);
		v1 = Math.abs(v2);
		}
	}

public void display(boolean [] G){
	for (int i = G.length-1; i>=0; i--) {
		if (G[i]) System.out.print(1);
		else System.out.print(0);
		}
	}

}












