public class Tester {
	boolean [] G;
	boolean [] B;
	public void start() {
		test(4);
 		}

public void test(int n) {
	for (int i=0; i<Math.pow(2,n); i++) {
		generateW(n,i);
		System.out.println();
		}
	}

/* ALGORITHM A6: GENERATE WIDTH 2**N WALSH FUNCTION CODE WORD i (0<=I<=2**N-1) */

public void generateW (int n, int i){ // ascending sequence
	generateW1(n,i,false);
	}

public void generateW1 (int m, int i, boolean d){ // d represents an inversion of all bits
   	if (m == 0) display(d);
   	else {
		generateW1(m-1, i/2, d);
		generateW1(m-1, i/2, d^((i%2)==1)^(((i/2)%2)==1));
		}
	}

public void display(boolean d){
	if (d) System.out.print(1);
	else System.out.print(0);
	}

}












